"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const cac_1 = require("cac");
const promises_1 = __importDefault(require("fs/promises"));
const path_1 = __importDefault(require("path"));
const cli = cac_1.cac('guru-cli');
async function loadCommands() {
    let files = await promises_1.default.readdir(path_1.default.resolve(__dirname, 'commands'));
    files = files.filter((file) => !file.includes('.d.ts'));
    const commands = await Promise.all(files.map(async (file) => await Promise.resolve().then(() => __importStar(require(path_1.default.resolve(__dirname, 'commands/', file))))));
    for (const { default: command } of commands) {
        await command(cli);
    }
}
async function run() {
    await loadCommands();
    cli.command('[...default]', 'display help if no command given').usage('--help').action(cli.outputHelp);
    cli.help();
    cli.parse();
}
exports.run = run;
if (require.main === module) {
    run().catch(console.error);
}
